final class MaxField {
	static BrainSettings s;
	final int size;
	double fields[][];
	boolean set[][];

	static void setBrainSettings(String file) throws Exception {
		s = new BrainSettings(file);
	}

	MaxField(board b) {
		size = b.getDimensions();
		fields = new double[size][size];
		set = new boolean[size][size];

		if (s == null)
			s = new BrainSettings();
	}

	void set(int x, int y, double value) {
		if (set[x][y])
			fields[x][y] = Math.max(fields[x][y], value);
		else {
			fields[x][y] = value;
			set[x][y] = true;
		}
	}

	void add(int x, int y, double value) {
		if (set[x][y])
			fields[x][y] += value;
		else {
			fields[x][y] = value;
			set[x][y] = true;
		}
	}

	void commit(SelectedMove [][] sm, String adder) {
		double scaler = s.getValue(adder);

		for(int y=0; y<size; y++) {
			for(int x=0; x<size; x++) {
				if (set[x][y])
					sm[x][y].addToValue(adder, fields[x][y] * scaler);
			}
		}
	}
}
