import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import javax.imageio.ImageIO;

class OutputMjpeg extends Output {
	private File f;
	private OutputStream os;

	public OutputMjpeg(String file) throws FileNotFoundException {
		f = new File(file);
		os = new FileOutputStream(f);
	}

	public void close() throws IOException {
		os.close();
	}

	public void emitBoard(int moveNr, board b, SelectedMove [][] sm, chainpiece selected, player selectedColor) throws IOException {
		BufferedImage output = drawBoard(moveNr, b, sm, selected, selectedColor);

		// write canvas to a file
		ImageIO.write(output, "jpg", os);
	}
}
