import java.util.*;

final class SelectedMove {
	double value;
	int count, dec, inc;
	scene s; // scene after this move
	List<String> adders = new ArrayList<String>();
	boolean isValid;
	final int x, y;

	SelectedMove(boolean isValid, int x, int y) {
		dec = inc = count = 0;
		s = null;
		this.isValid = isValid;
		this.x = x;
		this.y = y;
	}

	void invalidate() {
		isValid = false;
	}

	int getX() {
		return x;
	}

	int getY() {
		return y;
	}

        private void addAdder(String adder, Double value) {
                adders.add(adder + "=>" + value);
        }

	boolean isValidMove() {
		return isValid;
	}

	void addToValue(String adder, double value) {
		this.value += value;
		count++;

		if (value < 0)
			dec++;
		else if (value > 0)
			inc++;

		addAdder(adder, value);
	}

	int getInc() {
		return inc;
	}

	int getDec() {
		return dec;
	}

	int getCount() {
		return count;
	}

	double getValue() {
		return value;
	}

	scene getSceneAfterMoveNoCalc() {
		return s;
	}

	scene getSceneAfterMove(scene curScene, int x, int y, player myColor) {
		if (s != null)
			return s;

		s = curScene.doMove(x, y, myColor == player.white ? cross.white : cross.black, myColor);

		return s;
	}

        public String dump() {
                String output = "value: " + value + " (# inc: " + inc + ", # dec: " + dec + ")" + "Chosen by: ";

                for(String adder : adders)
                        output += adder + ", ";

                return output;
        }
}
