import java.util.*;
import java.io.*;

final class Statics {
        static String logFile = null;
	static boolean verbose = false;

	static boolean isInThisChain(final List<chainpiece> list, final int x, final int y) {
                for(final chainpiece current : list) {
                        if (current.getX() == x && current.getY() == y)
                                return true;
                }

		return false;
	}

	static void setVerbose(final boolean verboseIn) {
		verbose = verboseIn;
	}

        static void log(String what) {
                Date date = new Date();
                what = date.toString() + " " + what;

		if (verbose)
			System.out.println(what);

                if (logFile != null) {
                        try {
                                FileWriter file = new FileWriter(logFile, true);
                                PrintWriter pw = new PrintWriter(file);
                                pw.println(what);

                                pw.flush();
                                pw.close();
                        }
                        catch(Exception e) {
                                System.err.println("Failed to write to logfile");
                        }
                }
        }

	static void logBoard(board b, String what) {
		String row = "";

		for(int y=b.getDimensions()-1; y>=0; y--) {
			String nr = "  " + (y + 1);
			row = nr.substring(nr.length() - 2) + "|";

			for(int x=0; x<b.getDimensions(); x++) {
				if (b.getAt(x, y) == cross.white)
					row += 'w';
				else if (b.getAt(x, y) == cross.black)
					row += 'b';
				else
					row += '.';
			}

			Statics.log(what + row);
		}

		row = what + "  +";

		// FIXME Java has some kind of shortcut to add one char multiple times
		for(int loop=0; loop<b.getDimensions(); loop++)
			row += '-';

		Statics.log(row);

		row = what + "   ";
		for(int loop=0, index=0; loop<b.getDimensions(); loop++)
		{
			if (loop == 8)
				index++;
			row += "" + (char)('A' + index);
			index++;
		}

		Statics.log(row);

		Statics.log(what + " hash: " + b.getHash());
	}

	public static void setLogFile(String logFile) {
		Statics.logFile = logFile;
	}

	static String genMoveString(int x, int y) {
		int displayX;

		if (x >= 8)
			displayX = x + 1;
		else
			displayX = x;

		return "" + (char)('a' + displayX) + (1 + y);
	}
}
