final class chainpiece {
	final int x, y;

	chainpiece(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public boolean equals(Object other) {
		chainpiece o = (chainpiece)other;

		return o.getX() == x && o.getY() == y;
	}

	public int compareTo(Object otherIn) {
		chainpiece other = (chainpiece)otherIn;

		int v1 = (x << 16) | y;
		int v2 = (other.getX() << 16) | other.getY();

		return v1 - v2;
	}

	public int hashCode() {
		// so there's a limit for the boardsize
		// at 65535x65535: after that things get
		// tricky
		return (x << 16) ^ y;
	}

	chainpiece duplicate() {
		return new chainpiece(x, y);
	}

	final int getX() {
		return x;
	}

	final int getY() {
		return y;
	}
}
