import java.util.*;

final class scene {
	board b = null;
	List<chain> chains = null;
	int white_points = 0, black_points = 0;
	int nowWhiteCaptured = 0, nowBlackCaptured = 0;
	List<History> history = null;
	List<chainpiece> whiteCaught = null;
	List<chainpiece> blackCaught = null;
	SelectedMove [][] selectedMovesWhite = null, selectedMovesBlack = null;
	player playerWhoCausedThisScene = null;

	player selectedMovesInitted = null;
	int nFreedoms = 0;

	chainpiece moveThatLedToThisScene = null;
	int stonesCapturedInMTLTTS = 0;

	int capturedWhite() {
		return nowWhiteCaptured;
	}

	int capturedBlack() {
		return nowBlackCaptured;
	}

	boolean haveSelectedMoves(player moverColor) {
		if (moverColor == player.white)
			return selectedMovesWhite != null;

		return selectedMovesBlack != null;
	}

	SelectedMove [][] getSelectedMoves(player moverColor) {
		if (moverColor == player.white)
			return selectedMovesWhite;

		return selectedMovesBlack;
	}

	int getNFreedoms(player who) {
		initSelectedMoves(who);

		return nFreedoms;
	}

	void initSelectedMoves(player moverColor) {
		if (selectedMovesInitted != moverColor) {
			selectedMovesInitted = moverColor;

			int dim = b.getDimensions();
			int dimm = dim - 1;
			cross myObj = moverColor == player.white ? cross.white : cross.black;

			boolean [][] bitmap = new boolean[dim][dim];

			// first checks: empty fields and fields with freedoms
			for(int y=0; y<dim; y++) {
				for(int x=0; x<dim; x++) {
					if (b.getAt(x, y) != cross.empty)
						continue;

					if (x > 0    && b.getAt(x - 1, y) == cross.empty) {
						bitmap[x][y] = true;
						continue;
					}

					if (x < dimm && b.getAt(x + 1, y) == cross.empty) {
						bitmap[x][y] = true;
						continue;
					}

					if (y > 0    && b.getAt(x, y - 1) == cross.empty) {
						bitmap[x][y] = true;
						continue;
					}

					if (y < dimm && b.getAt(x, y + 1) == cross.empty) {
						bitmap[x][y] = true;
						continue;
					}
				}
			}

			// mark freedoms around my chains
			for(chain current_chain : chains)
			{
				if (current_chain.getColor() != moverColor)
					continue;

				List<chainpiece> currentFreedoms = current_chain.getFreedoms();

				if (currentFreedoms.size() > 1) {
					for(chainpiece current_piece : currentFreedoms)
						bitmap[current_piece.getX()][current_piece.getY()] = true;
				}
			}

			// check if one of the 4 chains connected to x,y is opponent and if opponent and it only has one
			// freedom, then still put as it'll kill that opponent chain
			for(chain current_chain : chains)
			{
				if (current_chain.getColor() == moverColor)
					continue;

				List<chainpiece> currentFreedoms = current_chain.getFreedoms();

				if (currentFreedoms.size() == 1)
				{
					for(chainpiece current_piece : currentFreedoms)
						bitmap[current_piece.getX()][current_piece.getY()] = true;
				}
			}

			// create selectedmoves thingy
			SelectedMove [][] selectedMoves;
			if (moverColor == player.white)
				selectedMoves = selectedMovesWhite = new SelectedMove[dim][dim];
			else
				selectedMoves = selectedMovesBlack = new SelectedMove[dim][dim];

			for(int y=0; y<dim; y++) {
				for(int x=0; x<dim; x++) {
					selectedMoves[x][y] = new SelectedMove(bitmap[x][y], x, y);

					if (bitmap[x][y])
						nFreedoms++;
				}
	// FIXME add super ko check
			}
		}
	}

	scene getSceneAfterMoveNoCalc(int x, int y, player moverColor) {
		if (moverColor == player.white)
			return selectedMovesWhite[x][y].getSceneAfterMoveNoCalc();

		return selectedMovesBlack[x][y].getSceneAfterMoveNoCalc();
	}

	scene getSceneAfterMove(int x, int y, player moverColor) {
		if (moverColor == player.white)
			return selectedMovesWhite[x][y].getSceneAfterMove(this, x, y, moverColor);

		return selectedMovesBlack[x][y].getSceneAfterMove(this, x, y, moverColor);
	}

	boolean getMoveAfterMoveIsValid(int x, int y, player moverColor) {
		if (moverColor == player.white)
			return selectedMovesWhite[x][y].isValidMove();

		return selectedMovesBlack[x][y].isValidMove();
	}

	void destructor() {
		b = null;
		for(chain current : chains)
			current.destructor();
		chains.clear();
		chains = null;
		history.clear();
		history = null;
		whiteCaught.clear();
		whiteCaught = null;
		blackCaught.clear();
		blackCaught = null;
		selectedMovesWhite = null;
		selectedMovesBlack = null;

		new BackgroundGarbageCollect().start();
	}

	List<chain> getChains() {
		return chains;
	}

	chainpiece getMoveThatLedToThisScene() {
		return moveThatLedToThisScene;
	}

	List<History> getHistory() {
		return history;
	}

	List<chainpiece> getWhiteCaught() {
		return whiteCaught;
	}

	List<chainpiece> getBlackCaught() {
		return blackCaught;
	}

	int getStonesCapturedInMTLTTS() {
		return stonesCapturedInMTLTTS;
	}

	player getWhoCausedThisScene() {
		return playerWhoCausedThisScene;
	}

	scene(int dimensions, boolean is_test) {
		b = new board(dimensions, is_test);
		chains = new ArrayList<chain>();
		findChains();

		history = new ArrayList<History>();

		whiteCaught = new ArrayList<chainpiece>();
		blackCaught = new ArrayList<chainpiece>();
	}

	// myColor is the color of the person that did this move
	scene(board parent_board, int x, int y, cross type, player myColor, int white_points, int black_points, List<History> history, List<chainpiece> whiteCaught, List<chainpiece> blackCaught) {
		playerWhoCausedThisScene = myColor;

		b = parent_board.doMove(x, y, type);
//		Statics.logBoard(b, "after move ");
		chains = new ArrayList<chain>();
		findChains();

		this.whiteCaught = new ArrayList<chainpiece>();
		this.blackCaught = new ArrayList<chainpiece>();
		this.whiteCaught.addAll(whiteCaught);
		this.blackCaught.addAll(blackCaught);
/* TEST		for(chainpiece current : whiteCaught)
			this.whiteCaught.add(current.duplicate());
		for(chainpiece current : blackCaught)
			this.blackCaught.add(current.duplicate()); */
		if (myColor == player.white)
			Brain.removeFromChainPieceList(this.whiteCaught, x, y);
		else
			Brain.removeFromChainPieceList(this.blackCaught, x, y);

		if (myColor == player.white)
			nowWhiteCaptured = stonesCapturedInMTLTTS = this.white_points = purgeChains(player.black, x, y);
		else
			nowBlackCaptured = stonesCapturedInMTLTTS = this.black_points = purgeChains(player.white, x, y);
//		Statics.logBoard(b, "after pc ");
		moveThatLedToThisScene = new chainpiece(x, y);

		this.white_points += white_points;
		this.black_points += black_points;

		this.history = new ArrayList<History>();
		this.history.addAll(history);
		this.history.add(new History(parent_board, x, y, myColor));
	}

	private int purgeChains(player whos_pieces, int moveX, int moveY) {
		int n_cleared = 0;

		for(int index=0; index<chains.size();) {
			final chain curChain = chains.get(index);

			if (curChain.getFreedoms().size() == 0) {
				// this happens *.*
				//              o*o
				//              .o. when in the lower right * places a piece
				// the one above it should dis-appear but the point is the one
				// in the lower right has, for a moment, no freedoms so it
				// looks like suicide, but it isn't
				if (curChain.getColor() != whos_pieces && curChain.isInThisChain(moveX, moveY) == true) {
					index++;
					continue;
				}

                                //assert chains.get(index).getColor() == whos_pieces;
                                if (curChain.getColor() != whos_pieces) {
                                        Statics.log("faulted chain: " + chains.get(index).dump());
                                        assert 0 == 1;
                                }

				List<chainpiece> list = curChain.getList();
				for(chainpiece current_piece : list) {
					assert b.getAt(current_piece.getX(), current_piece.getY()) == (whos_pieces == player.white ? cross.white : cross.black);

					b.clear(current_piece.getX(), current_piece.getY());

					if (whos_pieces == player.white)
						whiteCaught.add(current_piece);
					else
						blackCaught.add(current_piece);
				}
				n_cleared += list.size();

				chains.remove(index);
			}
			else {
				index++;
			}
		}

		/* needed as the freedoms change when some chains are purged */
		for(chain current_chain : chains) {
			current_chain.resetFreedomsList();

			assert current_chain.getFreedoms().size() != 0;
		}

		return n_cleared;
	}

	scene doMove(int x, int y, cross type, player myColor) {
		assert x>=0 && y>=0 && x<b.getDimensions() && y<b.getDimensions();
		assert type == cross.white || type == cross.black;

		return new scene(b, x, y, type, myColor, white_points, black_points, history, whiteCaught, blackCaught);
	}

	int getWhitePoints() {
		return white_points;
	}

	int getBlackPoints() {
		return black_points;
	}

	void setTestBoard() {
		String [] test = {
			".........",
			".........",
			".........",
			".........",
			"....wwwww",
			"wwww.....",
			".........",
			".........",
			"........." };

		for(int by=0; by<9; by++) {
			int sy = 8 - by;

			for(int x=0; x<9; x++) {
				if (test[sy].substring(x, x + 1).equals("w"))
					b.putAt(x, by, cross.white);
				else if (test[sy].substring(x, x + 1).equals("b"))
					b.putAt(x, by, cross.black);
			}
		}
	}

	board getBoard() {
		return b;
	}

	void dumpChains() {
		for(chain current_chain: chains) {
			System.out.print("Chain: ");
			current_chain.dump();
		}
	}

	SelectedMove decideMove(player myColor, boolean random_allowed, boolean deep, double thinkTime, List<Output> outputs, int moveNr) throws InterruptedException {
		initSelectedMoves(myColor);

		if (myColor == player.white)
			return Brain.decideMove(selectedMovesWhite, this, myColor, random_allowed, deep, thinkTime, outputs, moveNr);

		return Brain.decideMove(selectedMovesBlack, this, myColor, random_allowed, deep, thinkTime, outputs, moveNr);
	}

	private void findChains() {
		final int dim = b.getDimensions();
		board bcopy = b.duplicateBoard();

		for(int y=0; y<dim; y++) {
			for(int x=0; x<dim; x++) {
				cross current = bcopy.getAt(x, y);

				if (current == cross.empty)
					continue;

				player current_color = current == cross.white ? player.white : player.black;

				ArrayDeque<chainpiece> workOn = new ArrayDeque<chainpiece>();
				workOn.add(new chainpiece(x, y));

				chain chain = new chain(b, current_color);

				while(!workOn.isEmpty()) {
					chainpiece cp = workOn.poll();
					int workX = cp.getX(), workY = cp.getY();

					// in case an other queue-entry worked on this
					// (there are multiple roads to rome)
					if (bcopy.getAt(workX, workY) != current)
						continue;

					bcopy.clear(workX, workY);
					chain.addPiece(cp);

					if (workX > 0 && bcopy.getAt(workX - 1, workY) == current)
						workOn.add(new chainpiece(workX - 1, workY));

					if (workX < dim - 1 && bcopy.getAt(workX + 1, workY) == current)
						workOn.add(new chainpiece(workX + 1, workY));

					if (workY > 0 && bcopy.getAt(workX, workY - 1) == current)
						workOn.add(new chainpiece(workX, workY - 1));

					if (workY < dim - 1 && bcopy.getAt(workX, workY + 1) == current)
						workOn.add(new chainpiece(workX, workY + 1));
				}

				chains.add(chain);
			}
		}
	}
}
