import java.io.*;
import java.util.ArrayList;
import java.util.List;

final class test {
	static void loop(int dimensions, boolean random_allowed, double thinkTime, boolean deep, List<Output> outputs) throws InterruptedException {
		int pass = 0;
		int iteration = 0;
		int nNodes = 0, nMoves = 0;
//for(;;)
{
		iteration++;
		Statics.log("Iteration: " + iteration);
		scene s = new scene(dimensions, false);
		player current_player = player.black;

		System.out.println("stop v" + Version.getVersion() + ", (C) 2009-2015 by folkert@vanheusden.com");
		System.out.println("");

		Statics.log("Start test-run");

		long mainStartTs = System.currentTimeMillis();
		for(;;)
		{
			board b = s.getBoard();
			console.displayBoard(b, true);
			System.out.println("White/black points: " + Brain.countTrompTaylorPoins(b, player.white) + "/" + Brain.countTrompTaylorPoins(b, player.black));

			SelectedMove selectedMove;
			long startTs = System.currentTimeMillis();
			selectedMove = s.decideMove(current_player, random_allowed, deep, thinkTime, outputs, nMoves);
			nMoves++;
			nNodes += Brain.getNodesProcessedCnt();
			long endTs = System.currentTimeMillis();
			int x = -1, y = -1;
			if (selectedMove == null)
				System.out.println("Pass");
			else
			{
				x = selectedMove.getX();
				y = selectedMove.getY();

				System.out.println("My move: " + (char)('a' + x) + (1 + y) + ", " + selectedMove.dump());
				Statics.log("Move: " + (char)('a' + x) + (1 + y) + ", " + selectedMove.dump());
			}
			System.out.println("Took: " + ((double)(endTs - startTs) / 1000.0) + "s");
			if (x != -1 && y != -1)
			{
				cross type = cross.empty;

				if (current_player == player.white)
					type = cross.white;
				else
					type = cross.black;

				scene oldScene = s;
				s = s.doMove(x, y, type, current_player);
				oldScene.destructor();
				pass = 0;
			}
			else
			{
				pass++;
				if (pass >= 2)
				{
					System.out.println("Both gave up");
					Statics.log("Both gave up");
					break;
				}
			}

			if (current_player == player.white)
				current_player = player.black;
			else
				current_player = player.white;
		}
		long mainEndTs = System.currentTimeMillis();

		System.out.println("Took " + ((mainEndTs - mainStartTs) / 1000.0) + " seconds to run.");
		System.out.println("Average number of nodes: " + ((double)nNodes / (double)nMoves) + ", total nodes: " + nNodes);

}
//		Runtime.getRuntime().halt(123);
}
}
